.386
.model flat,stdcall
option casemap:none

include		\LEMKE\MyDefs.inc
include		\LEMKE\MyEqus.inc
include		\LEMKE\MyStructs.inc
include		\LEMKE\MyProtos.inc
include		\LEMKE\MyInterFaces.inc

includelib	\LEMKE\Lib\kernel32.lib
includelib	\LEMKE\Lib\user32.lib
includelib	\LEMKE\Lib\ole32.lib
includelib	\LEMKE\Lib\comctl32.lib
includelib	\LEMKE\Lib\shell32.lib

WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
TV_AddItem	PROTO :HWND, :DWORD,:DWORD,:DWORD,:DWORD,:BOOL,:BOOL

IDropTarget_QueryInterfaceProc	PROTO :DWORD,:DWORD,:DWORD
IDropTarget_AddRefProc		PROTO :DWORD
IDropTarget_ReleaseProc		PROTO :DWORD
IDropTarget_DragEnterProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
IDropTarget_DragOverProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
IDropTarget_DragLeaveProc	PROTO :DWORD
IDropTarget_DropProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

IDROPTARGET STRUCT
	QueryInterface	DWORD	OFFSET IDropTarget_QueryInterfaceProc
	AddRef		DWORD	OFFSET IDropTarget_AddRefProc
	Release		DWORD	OFFSET IDropTarget_ReleaseProc
	DragEnter	DWORD	OFFSET IDropTarget_DragEnterProc
	DragOver	DWORD	OFFSET IDropTarget_DragOverProc
	DragLeave	DWORD	OFFSET IDropTarget_DragLeaveProc
	Drop		DWORD	OFFSET IDropTarget_DropProc
IDROPTARGET ENDS

CDROPTARGET STRUCT
	interface	IDROPTARGET	<>
	cRef		DWORD	?
	hwndIDropTarget	DWORD	?
	bAcceptDrop	BOOLEAN	?
CDROPTARGET ENDS

.data

lpIDropTarget	DWORD	OFFSET CDropTarget

CDropTarget	CDROPTARGET	<>

ClassName	BYTE	"Drag-n-DropClass",0
AppName		BYTE	"Drag-n-Drop",0
TreeViewClass	BYTE	"SysTreeView32",0

.data?

hInstance	HINSTANCE	?
CommandLine	LPSTR		?

hwnd		HANDLE		?
hIcon		HANDLE		?
hwndTV		HANDLE		?

.const

IDI_LOGO	equ		500

.code

Start:

	INVOKE	GetModuleHandle,NULL								;kernel32.dll

	mov	hInstance,eax

	INVOKE	GetCommandLine									;kernel32.dll

	mov	CommandLine,eax

	INVOKE	OleInitialize,NULL								;ole32.dll

	INVOKE	WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

	INVOKE	OleUninitialize									;ole32.dll

	INVOKE	ExitProcess,eax									;kernel32.dll

	INVOKE	InitCommonControls	;comctl32.dll

include		\LEMKE\Drag-n-Drop\Drag-n-DropWinMain.asm
include		\LEMKE\Drag-n-Drop\Drag-n-DropWndProc.asm
include		\LEMKE\Drag-n-Drop\IDropTarget_QueryInterfaceProc.asm
include		\LEMKE\Drag-n-Drop\IDropTarget_AddRefProc.asm
include		\LEMKE\Drag-n-Drop\IDropTarget_ReleaseProc.asm
include		\LEMKE\Drag-n-Drop\IDropTarget_DragEnterProc.asm
include		\LEMKE\Drag-n-Drop\IDropTarget_DragOverProc.asm
include		\LEMKE\Drag-n-Drop\IDropTarget_DragLeaveProc.asm
include		\LEMKE\Drag-n-Drop\IDropTarget_DropProc.asm
include		\LEMKE\Drag-n-Drop\TV_AddItem.asm

END Start