WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	hdc:HDC 
	LOCAL	ps:PAINTSTRUCT 
	LOCAL	Rect:RECT

	mov	eax,uMsg
	cmp	eax,WM_CREATE
	jne	WP0000

	INVOKE	GetClientRect,hWnd,ADDR Rect	;user32.dll

	sub	Rect.right,20
	sub	Rect.bottom,20

	INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_ACCEPTFILES,ADDR TreeViewClass,NULL,\				;user32.dll
		WS_CHILD or WS_VISIBLE or TVS_HASBUTTONS or TVS_HASLINES or TVS_LINESATROOT or TVS_SHOWSELALWAYS,\
		10,10,Rect.right,Rect.bottom,hWnd,1,hInstance,NULL

	mov	hwndTV,eax

	INVOKE	RegisterDragDrop,hwndTV,ADDR lpIDropTarget

	INVOKE	TV_AddItem,hwndTV,TVI_ROOT,offset TreeViewClass,0,0,TRUE,TRUE

	INVOKE	SetFocus,hwndTV	;user32.dll

	INVOKE	SendMessage,hwndTV,TVM_GETNEXTITEM,TVGN_ROOT,0		;user32.dll

	mov	edx,eax

	push	edx

	INVOKE	TV_AddItem,hwndTV,edx,offset ClassName,0,0,FALSE,FALSE

	pop	edx

	INVOKE	TV_AddItem,hwndTV,edx,offset AppName,0,0,FALSE,TRUE

	xor	eax,eax
	ret
WP0000:
	cmp	eax,WM_COMMAND
	jne	WP0001

	xor	eax,eax
	ret
WP0001:
	cmp	eax,WM_PAINT
	jne	WP0002

	INVOKE	BeginPaint,hwnd,ADDR ps				;user32.dll

	mov	hdc,eax

	INVOKE	EndPaint,hWnd,ADDR ps				;user32.dll

	xor	eax,eax
	ret
WP0002:
	cmp	eax,WM_DESTROY
	jne	WP0086

	INVOKE	RevokeDragDrop,hwndTV

	INVOKE	PostQuitMessage,NULL				;user32.dll	FINISHED

	xor	eax,eax
	ret
WP0086:
	INVOKE	DefWindowProc,hWnd,uMsg,wParam,lParam		;user32.dll

	ret

WndProc ENDP