;TV_AddItem	PROTO :HWND,:DWORD,:DWORD,:DWORD,:DWORD,:BOOL,:BOOL

TV_AddItem PROC hTreeview:HWND,hParentItem:DWORD,lpszText:DWORD,imgNormal:DWORD,imgSelected:DWORD,fBold:BOOL,fSort:BOOL
	LOCAL	tvins:TV_INSERTSTRUCT
	
	mov	eax,hParentItem
	mov	tvins.hParent,eax
	cmp	fSort,TRUE
	jne	TV_AddItem00000

	mov	eax,TVI_SORT
	jmp	TV_AddItem00001

TV_AddItem00000:

	mov	eax,TVI_LAST

TV_AddItem00001:

	mov	tvins.hInsertAfter,eax
	mov	tvins.item._mask,TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
	cmp	fBold,TRUE
	jne	TV_AddItem00002

	or	tvins.item._mask,TVIF_STATE
	mov	tvins.item.state,TVIS_BOLD
	mov	tvins.item.stateMask,TVIS_BOLD

TV_AddItem00002:

	mov	eax,lpszText
	mov	tvins.item.pszText,eax
	mov	eax,imgNormal
	mov	tvins.item.iImage,eax
	mov	eax,imgSelected
	mov	tvins.item.iSelectedImage,eax

	INVOKE	SendMessage,hTreeview,TVM_INSERTITEM,0,ADDR tvins	;user32.dll
	
	ret

TV_AddItem ENDP