IDropTarget_DropProc PROC lpSelfInterface:DWORD,pDataObject:DWORD,grfKeyState:DWORD,ptx:DWORD,pty:DWORD,pdwEffect:DWORD
	LOCAL	stEnumFORMATETC:DWORD
	LOCAL	formatetc:FORMATETC
	LOCAL	dwnum:DWORD
	LOCAL	stgmedium:STGMEDIUM
	LOCAL	hItem:DWORD
	LOCAL	Rect:RECT
	LOCAL	TV_HitTestInfo:TV_HITTESTINFO
	LOCAL	szDropFile[MAX_PATH]:BYTE

	INVOKE	GetWindowRect,hwndTV,ADDR Rect	;user32.dll

	mov	eax,ptx
	sub	eax,Rect.left
	mov	TV_HitTestInfo.pt.x,eax
	mov	eax,pty
	sub	eax,Rect.top
	mov	TV_HitTestInfo.pt.y,eax

	INVOKE	SendMessage,hwndTV,TVM_HITTEST,0,ADDR TV_HitTestInfo		;user32.dll

	or	eax,eax
	jnz	IDropTarget_DropProc00000

	INVOKE	SendMessage,hwndTV,TVM_GETNEXTITEM,TVGN_CARET,0

	or	eax,eax
	jz	IDropTarget_DropProc00086

IDropTarget_DropProc00000:

	mov	hItem,eax

	mov	edx,pDataObject
	mov	edx,[edx]

	INVOKE	(IDataObject PTR [edx]).EnumFormatEtc,pDataObject,DATADIR_GET,ADDR stEnumFORMATETC

	or	eax,eax
	jnz	IDropTarget_DropProc00086

IDropTarget_DropProc00001:

	mov	edx,stEnumFORMATETC
	mov	edx,[edx]

	INVOKE	(IEnumFORMATETC PTR [edx]).Next,stEnumFORMATETC,1,ADDR formatetc,ADDR dwnum

	or	eax,eax
	jnz	IDropTarget_DropProc00077

	cmp	formatetc.cfFormat,CF_HDROP
	jne	IDropTarget_DropProc00001

	cmp	formatetc.tymed,TYMED_HGLOBAL
	jne	IDropTarget_DropProc00001

	mov 	formatetc.ptd,NULL
	mov 	formatetc.dwAspect,DVASPECT_CONTENT
	mov 	formatetc.lindex,-1

	mov	edx,pDataObject
	mov	edx,[edx]

	INVOKE	(IDataObject PTR [edx]).QueryGetData,pDataObject,ADDR formatetc

	or	eax,eax
	jnz	IDropTarget_DropProc00001

	mov	edx,pDataObject
	mov	edx,[edx]

	INVOKE	(IDataObject PTR [edx]).GetData,pDataObject,ADDR formatetc,ADDR stgmedium

	or	eax,eax
	jnz	IDropTarget_DropProc00001

	INVOKE	GlobalLock,stgmedium.hGlobal

	mov 	ebx,eax

	INVOKE	DragQueryFile,ebx,-1,ADDR szDropFile,MAX_PATH

	mov 	edi,eax
	xor 	esi,esi

IDropTarget_DropProc00002:

	INVOKE	DragQueryFile,ebx,esi,ADDR szDropFile,MAX_PATH
			
	INVOKE	TV_AddItem,hwndTV,hItem,ADDR szDropFile,0,0,FALSE,TRUE

	inc 	esi
	dec 	edi
	jnz	IDropTarget_DropProc00002

	INVOKE	GlobalUnlock,stgmedium.hGlobal

	INVOKE	ReleaseStgMedium,ADDR stgmedium

	INVOKE	SendMessage,hwndTV,TVM_EXPAND,TVE_EXPAND,hItem

	jmp	IDropTarget_DropProc00001

IDropTarget_DropProc00077:

	mov	edx,stEnumFORMATETC
	mov	edx,[edx]

	INVOKE	(IEnumFORMATETC PTR [edx]).Release,stEnumFORMATETC

IDropTarget_DropProc00086:

	mov	eax,S_OK
	ret

IDropTarget_DropProc ENDP